![freeCodeCamp.org Social Banner](https://s3.amazonaws.com/freecodecamp/wide-social-banner.png)

[![Pull Requests Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen.svg?style=flat)](http://makeapullrequest.com)
[![first-timers-only Friendly](https://img.shields.io/badge/first--timers--only-friendly-blue.svg)](http://www.firsttimersonly.com/)
[![Open Source Helpers](https://www.codetriage.com/freecodecamp/freecodecamp/badges/users.svg)](https://www.codetriage.com/freecodecamp/freecodecamp)
[![Setup Automated](https://img.shields.io/badge/setup-automated-blue?logo=gitpod)](https://gitpod.io/from-referrer/)

## Benvenuti nel programma di studio del codice open source di freeCodeCamp.org!

[freeCodeCamp.org](https://www.freecodecamp.org) è una comunità amichevole dove puoi imparare a programmare gratuitamente. È gestito da una [non profit finanziata dal donatore 501(c)(3)](https://donate.freecodecamp.org) con lo scopo di aiutare milioni di adulti impegnati a passare alla tecnologia. La nostra comunità ha già aiutato più di 10.000 persone a ottenere il loro primo incarico di sviluppatore.

Il nostro curriculum stack completo di sviluppo web è completamente gratuito e autonomo. Abbiamo migliaia di sfide di codifica interattive per aiutarti ad espandere le tue capacità.

## Sommario

- [Certificazioni](#certificazioni)
- [La Piattaforma di apprendimento](#la-piattaforma-di-apprendimento)
- [Trovato un bug/errore di codice](#trovato-un-bugerrore-di-codice)
- [Trovato un problema di sicurezza](#trovato-un-problema-di-sicurezza)
- [Come Contribuire](#come-contribuire)
- [Stato di Piattaforma, Build e Distribuzione](#stato-di-piattaforma-build-e-distribuzione)
- [Licenza](#licenza)

### Certificazioni

freeCodeCamp.org offre diverse certificazioni gratuite per gli sviluppatori. Ciascuna di queste certificazioni prevede la realizzazione di 5 progetti di Web app, insieme a centinaia di sfide di codifica opzionali per aiutarti a prepararti per tali progetti. Estimiamo che ogni certificazione richiederà a un programmatore principiante circa 300 ore per guadagnarle.

Ognuno di questi 30 progetti nel curriculum di FreeCodeCamp.org ha le proprie richieste da tenere in conto quando costruire il progetto e test automatizzati. Questi ti aiutano a sviluppare il tuo progetto in modo incrementale e assicurarti di aver soddisfatto tutte le richieste prima di inviarlo.

È possibile inserire queste suite di test attraverso [CDN di FreeCodeCamp](https://cdn.freecodecamp.org/testable-projects-fcc/v1/bundle.js). Ciò significa che puoi creare questi progetti su siti Web come CodePen e Glitch o persino sull'ambiente di sviluppo del tuo computer locale.

Una volta ottenuto un certificato, lo avrai per sempre. Sarai sempre in grado di collegarti ad esso dal tuo LinkedIn o curriculum. E quando i tuoi potenziali datori di lavoro o clienti freelance cliccano su quel link, vedranno una certificazione verificata specifica per te.

L'unica eccezione a questo è nel caso in cui scopriamo violazioni della nostra [Politica sull'Onestà Accademica](https://www.freecodecamp.org/academic-honesty). Quando catturiamo le persone plagiando in modo inequivocabile (sottomettendo il codice o i progetti di altre persone come loro senza citazione), facciamo ciò che dovrebbero fare tutte le rigorose istituzioni di apprendimento - revociamo le loro certificazioni e bandiamo/proibiamo quelle persone.

Ecco le nostre sei certificazioni di base:

#### 1. Certificazione di Responsive Web Design

- [HTML di base e HTML5](https://learn.freecodecamp.org/responsive-web-design/basic-html-and-html5)
- [CSS di base](https://learn.freecodecamp.org/responsive-web-design/basic-css)
- [Design Visual Applicato](https://learn.freecodecamp.org/responsive-web-design/applied-visual-design)
- [Accessibilità applicata](https://learn.freecodecamp.org/responsive-web-design/applied-accessibility)
- [Principi di Responsive Web Design](https://learn.freecodecamp.org/responsive-web-design/responsive-web-design-principles)
- [CSS Flexbox](https://learn.freecodecamp.org/responsive-web-design/css-flexbox)
- [Griglia CSS](https://learn.freecodecamp.org/responsive-web-design/css-grid)
  <br />
  <br />
  **Progetti**: La Pagina tributo, Il Modulo di indagine, La Pagina di destinazione del prodotto, La Pagina di documentazione tecnica, La Pagina web del portafoglio personale

#### 2. Certificazione di algoritmi JavaScript e strutture di dati 

- [JavaScript di base](https://learn.freecodecamp.org/javascript-algorithms-and-data-structures/basic-javascript)
- [ES6](https://learn.freecodecamp.org/javascript-algorithms-and-data-structures/es6)
- [Espressioni regolari](https://learn.freecodecamp.org/javascript-algorithms-and-data-structures/regular-expressions)
- [Debugging](https://learn.freecodecamp.org/javascript-algorithms-and-data-structures/debugging)
- [Strutture dati di base](https://learn.freecodecamp.org/javascript-algorithms-and-data-structures/basic-data-structures)
- [Scripting dell'algoritmo](https://learn.freecodecamp.org/javascript-algorithms-and-data-structures/basic-algorithm-scripting)
- [Programmazione orientata agli oggetti](https://learn.freecodecamp.org/javascript-algorithms-and-data-structures/object-oriented-programming)
- [Programmazione funzionale](https://learn.freecodecamp.org/javascript-algorithms-and-data-structures/functional-programming)
- [Scripting di algoritmi intermedi](https://learn.freecodecamp.org/javascript-algorithms-and-data-structures/intermediate-algorithm-scripting)
  <br />
  <br />
  **Progetti**: Il Correttore di Palindrome, Convertitore dei numeri romani, La cifra di Cesare, Il validatore di numero telefonico, Il registratore di cassa

#### 3. Certificazione di Librerie Front End

- [Bootstrap](https://learn.freecodecamp.org/front-end-libraries/bootstrap)
- [jQuery](https://learn.freecodecamp.org/front-end-libraries/jquery)
- [Sass](https://learn.freecodecamp.org/front-end-libraries/sass)
- [React](https://learn.freecodecamp.org/front-end-libraries/react)
- [Redux](https://learn.freecodecamp.org/front-end-libraries/redux)
- [React e Redux](https://learn.freecodecamp.org/front-end-libraries/react-and-redux)
  <br />
  <br />
  **Progetti**: La Macchina di quote casuali, Il Visualizzatore di Markdown, La macchinetta Drum, La Calcolatrice JavaScript, L'orologio 25 + 5

#### 4. Certificazione visualizzazione dei dati

- [Visualizzazione dei dati con D3](https://learn.freecodecamp.org/data-visualization/data-visualization-with-d3)
- [API JSON e Ajax](https://learn.freecodecamp.org/data-visualization/json-apis-and-ajax)
  <br />
  <br />
  **Progetti**: Il Grafico a barre, Il Grafico a dispersione, La Mappa di calore, Mappa di coropleta, Diagramma della Mappa ad albero
  
#### 5. Certificazione API e Microservizi

- [Gestione dei pacchetti con Npm](https://learn.freecodecamp.org/apis-and-microservices/managing-packages-with-npm)
- [Node di base ed Express](https://learn.freecodecamp.org/apis-and-microservices/basic-node-and-express)
- [MongoDB e Mongoose](https://learn.freecodecamp.org/apis-and-microservices/mongodb-and-mongoose)
  <br />
  <br />
  **Progetti**: Il Microservizio Data e ora, Il Parser di richiesta dell'intestazione, L'accorciatore dell'URL, Il tracker/tracciatore dell'esercizio, I file di Metadata del Microservizio

#### 6. Certificazione della sicurezza delle informazioni e della garanzia della qualità

- [Sicurezza delle informazioni con HelmetJS](https://learn.freecodecamp.org/information-security-and-quality-assurance/information-security-with-helmetjs)
- [Garanzia di qualità e test con Chai](https://learn.freecodecamp.org/information-security-and-quality-assurance/quality-assurance-and-testing-with-chai)
- [Node avanzato ed Express](https://learn.freecodecamp.org/information-security-and-quality-assurance/advanced-node-and-express)
  <br />
  <br />
  **Progetti**: Il convertitore metrico-imperiale, Il tracker/tracciatore dei problemi, La biblioteca personale, Il controllo prezzi delle azioni, Il forum dei messaggi anonimi

#### Certificazione per lo sviluppo di Stack completo (Full Stack Development)

Una volta che avrai ottenuto tutte queste 6 certificazioni, potrai richiedere la certificazione di sviluppo completo dello stack/Full Stack Development FreeCodeCamp.org. Questa distinzione finale significa che hai completato circa 1.800 ore di codifica con una vasta gamma di strumenti di sviluppo web.

#### Certificazioni di Legacy

Abbiamo anche 3 certificazioni di legacy dal nostro curriculum nel 2015, che sono ancora disponibili. Tutti i progetti richiesti per queste certificazioni di legacy rimarranno disponibili su freeCodeCamp.org.

- Certificazione di legacy dello sviluppo front end  (Legacy Front End Development)
- Certificazione di legacy della visualizzazione dei dati (Legacy Data Visualization Certification)
- Certificazione di legacy del back end (Legacy Back End Development Certification)
- Certificazione di legacy di sicurezza delle informazioni e garanzia di qualità (Legacy Information Security and Quality Assurance Certification)

### La piattaforma di apprendimento

Questo codice è in esecuzione in diretta su [freeCodeCamp.org](https://www.freecodecamp.org).

La nostra comunità ha tra l'altro:

- Un [forum](https://forum.freecodecamp.org) dove puoi ottenere aiuto su programmazione, o feedback sui tuoi progetti in alcune ore
- Un popolare [canale YouTube](https://youtube.com/freecodecamp) con corsi gratuiti su Python, SQL, Android, e un'ampia varietà di altre tecnologie
- Un [podcast](https://podcast.freecodecamp.org/) con approfondimenti sulla tecnologia e inspiranti storie di sviluppatori.
- Una pubblicazione di [Developer News](https://www.freecodecamp.org/news), un sito gratuito, open source e senza pubblicità per il cross-post degli articoli del tuo blog.

> [Unisciti alla nostra community qui](https://www.freecodecamp.org/signin).

### Trovato un bug/errore di codice?

Se pensi di aver trovato un bug/errore di codice, leggi prima l'articolo [Aiuto ho trovato un bug/errore di codice](https://forum.freecodecamp.org/t/how-to-report-a-bug/19543) e segui le sue istruzioni.

Se sei sicuro che sia un nuovo bug/errore di codice e hai confermato che qualcun altro si trova di fronte allo stesso problema, procedi e crea un nuovo problema con GitHub. Assicurati di includere quante più informazioni possibili in modo che possiamo riprodurre il bug/errore di codice.

### Trovato un problema di sicurezza?

Si prega di non creare problemi GitHub per i problemi di sicurezza. Invece, si prega di inviare una mail a `security@freecodecamp.org` e lo esamineremo immediatamente.

Appreziamo la comunicazione responsabile delle vulnerabilità che possono avere un impatto sulla integrità della nostra piattaforma e dei nostri utenti. Anche se non offriamo nessuna taglia o premio in questo momento, saremo felici di includere il tuo nome nella nostra [lista di personaggi famosi (Hall of Fame)](../../../HoF.md) per la ricerca della sicurezza.

### Come Contribuire

La comunità di freeCodeCamp.org è possible grazie ai migliaia di meravigliosi volontari come te. Apprezziamo ogni tipo di contributo alla comunità, e siamo felici di averti a bordo.

> #### [Per favore segui questi step per contribuire](CONTRIBUTING.md).

### Stato di Piattaforma, Build e Distribuzione 

Lo stato generale per tutte le nostre applicazioni è disponibile a [`status.freecodecamp.org`](https://status.freecodecamp.org). Gli stati di build e distribuzione sono disponibili nella [nostra Guida DevOps](../../devops.md).

### Licenza

Copyright © 2020 freeCodeCamp.org

Il contenuto di questa repository è vincolato dalle seguenti licenze:

- Il software del computer è concesso in licenza con la licenza [BSD-3-Clause](../../../LICENSE.md).
- Le risorse didattiche nella cartella [`/curriculum`](/curriculum) e le sue sottodirectory sono concessi in licenza [CC-BY-SA-4.0](../../../curriculum/LICENSE.md).
